/*
 	File:		NSLPluginModule.h
 
 	Contains:	Interface to API for using the NSL Manager
 
 	Version:	Mac OS 8.5
 
 	DRI:		Kevin Arnold
 
 	Copyright:	 1985-1999 by Apple Computer, Inc., all rights reserved
 
 	Warning:	*** APPLE INTERNAL USE ONLY ***
 				This file may contain unreleased API's
 
 	BuildInfo:	Built by:			Steve Simon
 				On:					6/14/99 10:29 AM
 				With Interfacer:	3.0d13   (MPW PowerPC)
 				From:				NSLPluginModule.i
 					Revision:		03
 					Dated:			06/14/99
 					Last change by:	sns
 					Last comment:	remove kNSLPluginNotKilled
 
 	Bugs:		Report bugs to Radar component "System Interfaces", "Latest"
 				List the version information (from above) in the Problem Description.
 
*/
#ifndef __NSLPLUGINMODULE__
#define __NSLPLUGINMODULE__

#ifndef __NSL__
#include <NSL.h>
#endif



#if PRAGMA_ONCE
#pragma once
#endif

#ifdef __cplusplus
extern "C" {
#endif

#if PRAGMA_IMPORT
#pragma import on
#endif

#if PRAGMA_STRUCT_ALIGN
	#pragma options align=mac68k
#elif PRAGMA_STRUCT_PACKPUSH
	#pragma pack(push, 2)
#elif PRAGMA_STRUCT_PACK
	#pragma pack(2)
#endif


OSStatus InitPlugin( void );
OSStatus KillPlugin( Boolean forceQuit );	
OSStatus Register( NSLTypedDataPtr dataPtr );
OSStatus Deregister( NSLTypedDataPtr dataPtr );
OSStatus StartNeighborhoodLookup( NSLNeighborhood neighborhood, NSLMgrNotifyUPP notifier, NSLPluginAsyncInfoPtr pluginInfo );
OSStatus StartServicesLookup( NSLNeighborhood neighborhood, NSLTypedDataPtr dataPtr, NSLMgrNotifyUPP notifier, NSLPluginAsyncInfoPtr pluginInfo );
OSStatus ContinueLookup( NSLMgrNotifyUPP notifier, NSLPluginAsyncInfoPtr pluginInfo );
OSStatus CancelLookup( NSLPluginAsyncInfoPtr pluginInfo );
OSStatus ErrNumToString( OSStatus theErr, char* errorString, char* solutionString  );





#if PRAGMA_STRUCT_ALIGN
	#pragma options align=reset
#elif PRAGMA_STRUCT_PACKPUSH
	#pragma pack(pop)
#elif PRAGMA_STRUCT_PACK
	#pragma pack()
#endif

#ifdef PRAGMA_IMPORT_OFF
#pragma import off
#elif PRAGMA_IMPORT
#pragma import reset
#endif

#ifdef __cplusplus
}
#endif

#endif /* __NSLPLUGINMODULE__ */

